;       - , , ;
;    

; R3:R4      
;R5- 
;R6- 
;R7- 
;R8- 
;R9- 
;R10- 

; 11.01.2015

.include "m16def.inc"

.equ	Fo=1000000
;.equ	Fo=4000000

.equ	External_Power=2

.def DC=R18
.def _FF =R2 ;FF
.def R_SEC=R25
.def R_MIN=R24
.def R_HOUR=R23

;**********************************************************
.cseg
.org 0x0000
	CLR	ZH			;     0
	LDI	R16,0b11111111
	MOV	_FF,R16
	OUT	SPH,ZH
	OUT	SPL,R16		;  
	OUT	DDRC,R16	;   C   0   

	OUT	DDRA,R16
	OUT	PORTA,R16

	OUT	DDRB,R16
	OUT	PORTB,R16

	RJMP	START
;**********************************************************
.org 0x000C
TIMER1_COMPA:
	OUT	PORTC,ZH	;    
	OUT	PORTA,_FF	;  
;*************************************************
;   
;EXT_POWER:
	SBIS	PIND,2
	RJMP	IND	;     
;*************************************************
	LDI	ZL,LOW(TB_DC*2)
	ADD	ZL,DC
	LPM

	LDI	ZL,5		;   ZH,ZL  R5
	ADD	ZL,DC
	LD	R16,Z		;    R5...R10  R16
POINT:	
	OUT	PORTC,R0
	OUT	PORTA,R16	;   
IND:
;     
	INC	DC
	CPI	DC,6
	BRLO	SCAN
	CLR	DC
SCAN:
	SBIW	YL,1
	BRMI	SEC_OUT
	BRNE	COMP1A_OUT
	
	OUT	OCR1AH,R3
	OUT	OCR1AL,R4	;      OCR1A
COMP1A_OUT:
	RETI
SEC_OUT:
	SET			;  1'000'000us 
	RET
;*************************************************
; -    C
TB_DIG:
	;     hgfedcba   hgfedcba
	.db 0b00111111,0b00000110 ;01
	.db 0b01011011,0b01001111 ;23
	.db 0b01100110,0b01101101 ;45
	.db 0b01111101,0b00000111 ;67
	.db 0b01111111,0b01101111 ;89
;	.db 0b00000000,0b00000000 ;  
;      A
TB_DC:
	;       
	.db 0b11011111,    0b11101111
	;       
	.db 0b11110111,    0b11111011
	;      
	.db 0b11111101,    0b11111110
;******************************************
START:
	OUT	DDRB,ZH
	OUT	DDRD,R16
	OUT	PORTD,R16

	CBI	DDRD,External_Power	;   D

	RJMP	TIME_BEGIN
GO:
	CLR	ZH
	LDI	R16,0b11111111
	OUT	SPH,ZH
	OUT	SPL,R16		;  

	SBI	ACSR,ACD	;   

	MOV	_FF,R16
	
	CLR	DC
	
	LDI	YH,HIGH(1199)
	LDI	YL,LOW(1199)	;  

	LDI	XH,HIGH(Fo-Fo/1200*1199-1)
	LDI	XL,LOW(Fo-Fo/1200*1199-1)
	MOV	R3,XH			;     1 
	MOV	R4,XL			;  

	LDI	XH,HIGH(Fo/1200-1)	; 8333     
	LDI	XL,LOW(Fo/1200-1)
	OUT	OCR1AH,XH
	OUT	OCR1AL,XL

	LDI	R16,(1<<SE)
	OUT	MCUCR,R16		; SLEEP ENABLE
	
	CLT
	
	SBI	PORTD,3		;   1 

	LDI	R16,1<<OCIE1A
	OUT	TIMSK,R16	;   Timer1_compA
	
	LDI	R16,(1<<WGM12|1<<CS10)		;9
	OUT	TCCR1B,R16	;  Fclk
	
	OUT	TIFR,_FF

	SEI 			;   
WAIT:
	SLEEP
	BRTC	WAIT
	CLT	
;**********************************************************
	CBI	PORTD,3		;   1 
;EXT_POWER:
	SBIS	PIND,2
	RJMP	INC_TIME	;       

KEY_MIN:
	SBIC	PINB,5
	RJMP	KEY_HOUR	;    MIN
 	INC	R_MIN		;  MIN
 	CPI	R_MIN,60
 	BRLO	MIN_60
 	CLR	R_MIN
MIN_60: 	
KEY_HOUR: 	
	SBIC	PINB,6	;    HOUR
	RJMP	KEY_PAUSE
 	INC	R_HOUR
 	CPI	R_HOUR,24
 	BRLO	KEY_PAUSE
 	CLR	R_HOUR
KEY_PAUSE:
	SBIC	PINB,7
	RJMP	INC_TIME
	
	RJMP	GO_TIME_PAUSE		;   
INC_TIME:
	INC	R_SEC
INC_TIME1:
	CPI	R_SEC,60
	BRLO	GO_TIME
	CLR	R_SEC
INC_MIN:
	INC	R_MIN
	CPI	R_MIN,60
	BRLO	GO_TIME
	CLR	R_MIN
INC_HOUR:
	INC	R_HOUR
	CPI	R_HOUR,24
	BRLO	GO_TIME
TIME_BEGIN:	
	CLR	R_HOUR
	CLR	R_MIN
GO_TIME_PAUSE:
	CLR	R_SEC
GO_TIME:
	RCALL	DIG_HOUR
	RCALL	DIG_MIN
	RCALL	DIG_SEC

	RJMP	GO
;**********************************************************
DIG_HOUR:
	MOV	R17,R_HOUR
	RCALL	BIN8_BCD3

	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R27
	LPM	R5,Z
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R28
	LPM	R6,Z

	RET
;*************************************************
DIG_MIN:
	MOV	R17,R_MIN
	RCALL	BIN8_BCD3

	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R27
	LPM	R7,Z
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R28
	LPM	R8,Z

	RET
;*************************************************
DIG_SEC:
	MOV	R17,R_SEC
	RCALL	BIN8_BCD3

	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R27
	LPM	R9,Z
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R28
	LPM	R10,Z

	RET
;*************************************************
BIN8_BCD3:
	CLR	R27		; BCD OUT 10,1

	LDI	R28,8
PR:
	subi r27,-0x33	;add 0x33
	sbrs r27, 3	;if carry to bit 3
	subi r27, 3	;subtract 3
	sbrs r27, 7	;if carry to bit 7
	subi r27, 0x30	;subtract 0x30

	LSL R17		;shift input*/
	ROL R27
   
	dec R28		;\n"
	brne PR		;repeat for all bits*/
	
	MOV		R28,R27
	ANDI	R28,$0F
	SWAP	R27
	ANDI	R27,$0F

	RET
.EXIT
